
/**
 * GRules

 * <PRE>
 
 * </PRE>
 * @version 1.0b1 05/01/99
 * @author Pierre-Mikael Legris (plegris@fbwww.epfl.ch)
 */              
public class GRules extends Rules  {
  public int tab[] = new int[14]; 

  /**
   *constructor 
   */
  public GRules () { 
    newGame();
  }
  
  //*** here are the rules ***

  /**
   * init the board
   */
  public void newGame() { 
    super.tab = tab;
    for (int i = 0 ; i < 14 ; i ++) { tab[i] = 1 ; }
  }

   /**
   * reverse the array, 
   */
  public int[] rtab(int[] stab) { //DNR
    return stab;
  }
  
  /** 
   * return true if this move is valid
   */
  public boolean v(int i,int[] ttab) { //DNR    
    return (ttab[i] != 0); // if it's unchecked
  }

  /** 
   * return true if the player can replay
   */
  public boolean r(int bol,int[] ttab) { //DNR
    return false; // players never replay at LL
  }

  /**
   * move, this method is called by move() it returns a new array 
   * for this move at this position on this board as if the paler was player 1
   */
  public int[] m(int i,int[] ttab) { //DNR
      int j = 14;
      if (i < 12) j = 12;
      if (i < 9) j = 9;
      if (i < 5) j = 5;
      
      for (int k=0 ; k < 14; k++) {
	  if (ttab[k] != 0) {
	      ttab[k] = 1;
	      if ((k >= i) && (k < j)) ttab[k] = 0;
	  }
      }
      return ttab;
  }

 
  /**
   * win, loose , tie
   * return 0 if not finished
   * 1 if this player win
   * 2 if the opponent win
   * -1 if it's a tie
   */
  public int w(int[] ttab) { //DNR
      for (int i = 0; i < 14; i++) {
	  if (ttab[i] != 0) 
	      return 0;
      }
      return 2;
   
  }
  

  /**
   * message to send a player when he plays something
   * if p = true that does mean it's for the player and false for the oponnent
   */
  // well obviously TicTacToe isn't a good example
  // for this one. Have a look to Mancala's rules
  // which have a better use of this
  public String msg(int bol,boolean p) { //DNR
    if (p) {                    
      return "You played";      
    }                          
    else return "Opponent played";
  } 
}












