import java.awt.*;
import java.applet.*;
import java.applet.Applet.*;
import java.net.*;
/**
 *<B>Gpanel:</B> for the jGDK
 * <PRE >
 * Gpanel is the UI of the human board game
 * </PRE>
 *@see Login 
 *@author Pierre-Mikael Legris (plegris@fbwww.epfl.ch)
 */ 
public class Gpanel extends Frame  {
  // UI vars

    Canvas title ;
    Label header = new Label("Giobsgame",Label.CENTER);
    Label move = new Label("MOVE");
    TextField chat = new TextField(); 
    Button stop = new Button("QUIT");
    Button sound = new Button("SOUND  OFF");
    Font defFont = new Font("Helvetica", Font.PLAIN , 12);
    Board gameBoard ;
    int tab[] ; 
    
    boolean horizBoard = true;
    private boolean myTurn = true;
    Dimension myDim = new Dimension(500,400);  
    String myName;
    Hplayer owner;
    
    String uid = "";
    String score = "";
    
    
    // constructor
    public Gpanel(String game,Hplayer owner) {
	this.owner = owner;
	setTitle("Giobsgame by Mandanet SA");
	try {
	    gameBoard = (Board) Class.forName(game).newInstance();
	} catch(Exception e) {
	    System.out.println(e);
	}
	
      gameBoard.init(this);
      
      if (jGDK.noisy ) jGDK.s_welcome.play();
	  
      title = new Pict("gg4.gif",247,71);
      makeUI();
      this.show();
      if (jGDK.noisy ) jGDK.s_play.loop();
	   
     
    }
    
 
  
    //play : player clicked on a bol
    public void play(int bol) {
	if ( myTurn ) {
	  owner.play(bol);
	}
    }
    
    //setName
    public void setName(String name) {
	myName = name;
    }

    public boolean getTurn() { return myTurn; } 
    
    public void setTurn(boolean turn) { 
	
	this.myTurn = false;
	if (turn) { 
	    this.myTurn = true ;  
	} 
	if (myTurn) {
	    move.setText("PLAY");
	    move.setBackground(Color.green);
	} else {
	    move.setText("WAIT");
	    move.setBackground(Color.red);
	}
	
    }

    //setTurn
    public void setTurn(boolean turn, int[] ttab) {
	System.out.println("G "+this.myTurn+" "+turn);
	setTurn(turn);
	for (int i = 0; i < ttab.length ; i++)
	    gameBoard.tab[i] = ttab[i];

	gameBoard.repaint();
    }

    public void print(String text) {
	System.out.println(text + "\n");
    }
  
    // make UI
    public void makeUI() {
	setLayout(new BorderLayout());
	setBackground(Color.white);
	header.setFont(new Font("Helvetica", Font.BOLD , 13));
	
	//header.setBackground(Color.blue);
	//header.setForeground(Color.white);

	Panel top = new Panel();
	top.add(title);
	add("North",top);

	Panel middle = new Panel();
	middle.setLayout(new BorderLayout());
	middle.add("Center",gameBoard);
	
	add("Center",middle);
	
	Panel bottom = new Panel();
	bottom.setLayout(new BorderLayout());
	
	bottom.add("East",stop);
	bottom.add("Center",header);
	bottom.add("South",move);
	bottom.add("West",sound);
	add("South",bottom);
	
	header.setText(uid+"    "+score);

	resize(myDim.width,myDim.height); 
	gameBoard.repaint();
	repaint();
	show(true);
    }
    
    public void die() {
	 jGDK.soundOn(false);
	 dispose();
	 System.exit(1);
	
    }
    
    // handleEvent
    public boolean handleEvent(Event evt) {
	if (evt.id == Event.WINDOW_DESTROY) {
	   die();
	}   
	return super.handleEvent(evt);
    }
    
    // handle actions
    public boolean action(Event e, Object o)
    {
	 if (e.target == stop) {
	     die();
	    
	 }         
	 if (e.target == sound) {
	     jGDK.soundOn(! jGDK.noisy);
	     sound.setLabel("Sound ON");
	     if (jGDK.noisy) 
		 sound.setLabel("Sound OFF");
	 } 
	 
	return true;    
    }

    public void setUID(String text) { 
	uid = text;
	header.setText(uid+"    "+score);
    };
    
    public void setScore(String text) { 
	score = text;
	header.setText(uid+"    "+score);
    };
   
    
    public void win(boolean did) {
	if (jGDK.noisy) jGDK.s_play.stop();
	String msg = "looser.gif";
	if (did) {
	    msg = "winner.gif";
	    if (jGDK.noisy) jGDK.s_win.play();
	} else {
	    if (jGDK.noisy) jGDK.s_loose.play();
	}

	Ebox tell = new Ebox(this,msg,true);
	tell.show(true);
	System.out.println("DONE");
	if (jGDK.noisy) jGDK.s_play.loop();
	owner.init2();
    }
      
}

















