
import java.applet.Applet;
import java.applet.*;
import java.awt.*;
import java.net.*;
import java.io.*;  

/**
 * @version 1.0b1 5 Feb 99
 * @author Pierre-Mikael Legris (plegris@fbwww.epfl.ch) 
 */
public class jGDK extends Applet
{
    
    Player player1;
    Player player2; 
    Rules rules;
    private boolean turn = true;
    
    
    String uid = "Perki";
    String score = "0  0";
   
    static String base = ""; 
    static AudioClip s_welcome , s_loose, s_play , s_win;
    static boolean noisy = true;
    public jGDK() {
	System.out.println("0");
    }

    public void init() { 
	System.out.println("1");
	
	try {
	    base = getCodeBase().toString();
	} catch (Exception e) {System.err.println(e);}
	
	
	
	System.out.println(""+base);
	try {
	    uid = getParameter("USER");
	    //    port = Integer.parseInt(getParameter("PORT"));
	} catch (Exception e) {System.err.println(e);}
        
	System.out.println("Giobsgame started user:"+uid);
	add(new Label("Giobsgame"));
	
	s_welcome = getSound("welcome.au");
	s_win = getSound("win.au");
	s_loose = getSound("loose.au");
	s_play = getSound("play.au");
	
	String args[] = {"G","h","c"};
	new jGDK(args);
    }
   
      public void start() {    
	System.out.println("2");
    }

    public void stop() {     
	 System.out.println("3");
    }
    

    /**
     *Constructeur, cree les deux joueurs ainsi que la regle puis lance un Thread jGDK
     */
     public jGDK(String args[]) {
	String l = args[0];
	try {
	    rules = (Rules) Class.forName(l+"Rules").newInstance();
	    
	    if (args[1].equals("h")) {
		player1 = new Hplayer();	
		player1.setName(l+"Board","1"); 
	    } else {
		player1 = (Player) Class.forName(l+"bot").newInstance();
		player1.setName("1");
	    }
	    
	    if (args[2].equals("h")) {
		player2 = new Hplayer();
		player2.setName(l+"Board","2");  
	    } else {
		player2 = (Player) Class.forName(l+"bot").newInstance();
		player2.setName("2");
	    }

	    } catch(Exception e) { 
		System.out.println(e); 
		System.exit(1);
	    }
	rules.setName1("1"); 
	
	player2.setOwner(this);
	player1.setOwner(this);

	player1.setUID(uid);
	init2();
    } 
    
    public void init2 () {
	link("1");
	player1.setScore(score);
	rules.newGame();
	player1.print("New Game started");
	player2.print("New Game started");
	if (! turn) {
	    player1.setTurn(false,rules.getTab("1"));
	    player2.setTurn(true,rules.getTab("2"));
	} else {
	    player2.setTurn(false,rules.getTab("2"));
	    player1.setTurn(true,rules.getTab("1"));
	}
	turn = !turn;
    }


    /**
     * log : just print a text on the console
     */
    void log(String s) {
	System.out.println(s);
    }

    synchronized void play(int i,Player player) {
	boolean replay = false;
	Player opponent;
	String name = player.getName();
	
	if (name.equals(player1.getName())) {
	    opponent = player2;
	} else {
	    opponent = player1;
	}
 	
  
	int[] tab;
	if(rules.verif(i,name) && player.getTurn()) {
	    replay = rules.replay(i,name);
	    tab = rules.move(i,name);
	    opponent.print(rules.msg(i,false));
	    player.print(rules.msg(i,true));
	} else {
	    log(name+" tried a bad move:"+i);
	}
	
	
	int win = rules.win(name);
    	    
	if (win == -1) {
	    opponent.print("draw ..");
	    player.print("draw ..");
	}
	if (win == 1) {
	    opponent.print("you loose");
	    player.print("you win");
	}
	if (win == 2) {
	    opponent.print("you win");
	    player.print("you loose");
	}   
	
	if (win != 0) {
	    player.setTurn(false,rules.getTab(name)); 
	    opponent.setTurn(false,rules.getTab(opponent.getName()));
	    if (player.getName().equals("2")) {
		player1.win(true);
		link("2");
	    } else {
		player1.win(false);
	    }
	    log("end .. ");
	} else {
	    player.setTurn(replay,rules.getTab(name));
	    opponent.setTurn(! player.getTurn(),rules.getTab(opponent.getName()));
	}
	
	
    } 

    void link(String code) {
	GetUrlString toto = new GetUrlString(base+"test.cgi?"+uid+"+"+code);
	while (toto.waitP()) {
	    try{
		Thread.sleep(1000);
	    } catch(InterruptedException e){}
	}
	
	if (toto.isOK()) {
	    System.out.println("Linked; "+code+" #  "+ toto.r_Res);
	} else {
	    System.out.println("Erreur \n " + toto.r_Err );
	}
	if (! toto.r_Res.equals("")) { 
	    score = toto.r_Res;
	}
	toto = null;	
    }

    
    
    public AudioClip getSound(String soundName) {
	URL tempURL = null;
	AudioClip tempSound = null;
	try {
	    tempURL = new URL(jGDK.base+soundName);
	    tempSound = getAudioClip(tempURL);
	} catch( MalformedURLException e ) {
	    System.out.println("image URL is bad "+ e);
	}
	System.out.println("downloaded "+tempURL);
	return tempSound;
    }


    static void soundOn(boolean turnOn) {
	s_welcome.stop();
	s_win.stop();
	s_loose.stop();
	s_play.stop();
	noisy = false;
	if ( turnOn ) {
	    noisy = true;
	    s_play.loop();
	} 
    }
}
