
/**
 * Abox
 * usage Abox(String who)
 * Want to play with Dialog box
 * This is opensource software
 * @version 1.0b1 23/04/98
 * @author Pierre-Mikael Legris (plegris@fbwww.epfl.ch)
 */ 

import java.awt.*;
import java.util.StringTokenizer;

class Abox extends Dialog
{
  private Button ok;
  private Button cancel;
  private TextField entry = new TextField( 20 ); 
  private String nick = "";
  private String game = "";
  Wpanel parent;

  //constructor
  Abox(Frame frame,String who,boolean modal) {
    super(frame,who,true);
    parent = (Wpanel)frame;
    StringTokenizer st = new StringTokenizer(who);
    if (st.countTokens() == 2) {
      this.nick = st.nextToken();
      this.game = st.nextToken();
    }
    this.resize(250, 200);
    setTitle(who);

    ok = new Button("OK");
    cancel = new Button("Cancel");
    
    setLayout(new GridLayout(5,1,2,2));
    add(new Label("Want to play with "+nick+" ?"));
    add(new Label("Game: "+game));
    add(new Label("Enter a message below"));
    add(entry);
    Panel butts = new Panel();
     butts.setLayout(new GridLayout(1,2,1,1));
     butts.add(ok);
     butts.add(cancel);
    
    add(butts);
    repaint();

    Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
    move((d.width - this.size().width) / 2,(d.height - this.size().height) / 2); 

  }
  
  //Handle event
  public boolean action(Event ev, Object obj) {
    // ok
    if (ev.target == ok) {
      String inText = entry.getText();
      if (inText.compareTo("") == 0) { inText = "hello" ; }
      inText = inText.replace('<','\\');
      inText = inText.replace('>','/');    
      parent.send("C<"+nick+">"+game+">"+inText);
      this.hide();
      this.dispose();
    }
    // cancel 
    if (ev.target == cancel) {
      this.hide();
      this.dispose();
    }
    return true;
  }
}// About
  







