
import java.applet.Applet;
import java.awt.*;
import java.net.*;
import java.io.*;
import java.util.StringTokenizer;

/**
 * Starting point for the client jgames <BR>
 * The applet default web page is named "login.html"<BR>
 * <BR>
 * version 1.0b1 26/04/98<BR>
 * author Pierre-Mikael Legris (plegris@fbwww.epfl.ch)<BR> 
 *
 * <PRE>
 *  Login
 *   connect to the server, when the nick is ok 
 *   create a new player : Wplayer and launch it in
 *   a new waiting room Wpanel
 *   
 *  Wplayer(nick , socket , comment)
 *   cf Human & Player (server side)   
 *
 *  Wpanel(Wplayer)
 *   this is the waiting room (client side of Mstream)
 *   when two users start a game die and give the user 
 *   to Gpanel
 *
 *  Gpanel(Wplayer , message)
 *   this is the Frame that display the game using
 *   MBoard and MRules (client side of Game)
 *
 *  Mboard()
 *   this is a canvas that display the game board and 
 *   feedback Gpanel with the moves
 *</PRE>
 *@version 1.0b1 26/04/98<BR>
 *@author Pierre-Mikael Legris (plegris@fbwww.epfl.ch)
 */
public class Login extends Applet implements Runnable {
  //UI vars
  Label header = new Label ("*** Jgames Login ***",Label.CENTER);
  Label result = new Label ("---------------------------------",Label.CENTER);
  Label result2 = new Label ("---------------------------------",Label.CENTER);
  Label help = new Label ("nickname");
  Label help2 = new Label ("comment");
  TextField entry = new TextField( 20 );
  TextField entry2 = new TextField( 20 );
  Button go = new Button ("Press HERE to play!");
  Label infos = new Label ("-----------------------------------",Label.CENTER);

  //vars
  Thread myThread;
  Socket s = null;
  String host = "";
  int port = 0;
  DataInputStream sin;
  PrintStream sout; 
  boolean connected = false;
  boolean loged = false;
  String ligne = "";
  String fnick = "";
  String fcomm = "";
  Wplayer me;
  Wpanel panel;
  static String sURL = "";

  // Start
  public void start() {
    if (myThread == null); {
      myThread = new Thread(this);
      myThread.start();
    }     
  }

   // Init
  public void init( ) {    
    System.out.println("Jgames Login  Pierre-Mikael Legris: plegris@fbwww.epfl.ch"); 
    makeUI( );
    try {
      sURL = getCodeBase().toString();
      System.out.println(sURL);
      host = getCodeBase().getHost();
      port = Integer.parseInt(getParameter("PORT"));
    } catch (Exception e) {System.err.println(e);} 
    
    infos.setText(" * connecting to Jgames Server * "); 
   
  }
  
  // run
  public void run() {
    // try to connect
    connected = true;
    try {
      this.s = new Socket(host,port);
      this.sout = new PrintStream(s.getOutputStream());
      this.sin = new DataInputStream(s.getInputStream());
    }
    catch (IOException e) {
      System.err.println(e);
      infos.setText(" * connection failed * ");
      go.setLabel("The server is down");
      connected = false;
    }
    if (connected) { infos.setText(" * connected to server * ");}
    
    // read the stream while not logged in
    ligne = "";
    while (connected && (! loged)) {
      try {
	ligne=sin.readLine();
	parseS(ligne);
      } catch (IOException e) {
	System.err.println(e);
	infos.setText(" * connection failed * ");
	go.setLabel("The server is down");
	connected = false;
	break;
      }
      try{ Thread.sleep(100); } catch(InterruptedException e){}      
    } 
  }

  // Parse the line
  public void parseS(String text) {
    StringTokenizer st = new StringTokenizer(text,"<");
    if ((st.countTokens() == 2) && connected);
    {
      if (st.nextToken().compareTo("Y") == 0) { 
	// Nick Ok user loged in
	loged = true;
	infos.setText(" *** User Loged In **** ");
        me = new Wplayer(fnick , s , fcomm);
	panel = new Wpanel(me);
	go.setLabel("Enjoy jGames");
      } else {
	// Invalid Nick
	result.setText("" + st.nextToken());
      }
    }
  }
  
  // Stop
  public void stop() {
    sin = null;
    me = null;
    panel = null;
    try {
      if (s != null) {
        s.close() ;
        s = null;
      }
    }
    catch (IOException e) { }

    if (myThread != null) {
      myThread.stop();
      myThread = null;
    }
    
    destroy();
  }   

  // Make UI
  public void makeUI() {
    setBackground(Color.white);
    header.setFont(new Font("Helvetica", Font.BOLD , 13));
    header.setBackground(Color.blue);
    go.setBackground(Color.lightGray);
    header.setForeground(Color.white);
    infos.setBackground(Color.yellow);
    setLayout(new GridLayout(7,1,1,1));
    add(header);
    add(result);
    add(result2);

    Panel ctrl1 = new Panel();
     ctrl1.setLayout(new BorderLayout());
      ctrl1.add("East",entry);
      ctrl1.add("West",help);
    Panel ctrl2 = new Panel();
     ctrl2.setLayout(new BorderLayout());
      ctrl2.add("East",entry2);
      ctrl2.add("West",help2);
    
    add(ctrl1);
    add(ctrl2);
    add(go);
    add(infos);
    repaint();
  }           

  // handle actions
  public boolean action(Event e, Object o)
  {
    if((e.target == go) && (! loged) && connected)
      {
        String nick = entry.getText().trim();
	nick = nick.replace(' ','_');
	nick = nick.replace('<','\\');
	nick = nick.replace('>','/');
        if(nick.length() > 8 ) {
          result.setText("*nick error* 8 characters max");
	  return true;
	}
	if(nick.compareTo("") == 0) {
	  result.setText("*nick error* 1 character min");
	  return true;
	}
	result.setText("nick:  " + nick);
	fnick = nick;
	String comm = entry2.getText().trim();
	comm = comm.replace('<','\\');
	comm = comm.replace('>','/');
	if(comm.length() > 20) {
	  result2.setText("*comment error* 20 characters max");
	  return true;
	}
	if(comm.compareTo("") == 0) {
	  comm = "-";
	}
	result2.setText("comment:  " + comm );
        if (connected && (! loged)) {
        this.fnick = nick;
	this.fcomm = comm;
        }
	// all tests passed send the query
	if (connected && (! loged)) {
	  try {
	    sout.println(nick + "<" + comm );
	  } catch (Exception ee) {
	    System.err.println(ee);
	    infos.setText(" * connection closed * ");
	    connected = false;
	  }
	}
      }
    return true;  
  }                    
  
 
}


















