
import java.awt.*;         

/**
 * MBoard
 * Mancala's Board
 * If you need more information on how it works have look to 
 * TBoard.java which is higly documented
 * @version 1.0b1 25/04/98
 * @author Pierre-Mikael Legris (plegris@fbwww.epfl.ch)
 */
class MBoard extends Board {
  // Independant variables int values can be changed
  int tab[] = {4,4,4,4,4,4,0,4,4,4,4,4,4,0}; //init tab
  int myW = 621; // width of pict
  int myH = 201; // heigth of pict
  boolean horizBoard = true; //DNR if you want the Board to be horizontal set this to true
   String help = "TicTacToe.html"; //DNR  

  // Vars for the game Mancala
  int b13W = 50 ;  //dimension bol0
  int b06W = 570 ;  //dimension bol0
  int bdW = 135 ; //depart bol Horiz
  int bhH = 43 ; //depart bol Haut
  int bbH = 157 ; //depart bol Bas
  int bbP = 70 ; //pas Horiz entre les bols
  int bD = 33 ; //lageur - hauteur des petits bols (/2)
  Font rFont = new Font("Helvetica", Font.BOLD , 24);
  FontMetrics rFM = getFontMetrics(rFont);
  String pictName = "mancala.gif";
  
  Image pict = null;
  Image billes[] = new Image[7]; //billes
  
  /**
   * Constructror
   */
  public MBoard() { } // DNC
  
 
  /**
   * initialization of the Board
   * this method is called only once, at the start of the Game.
   */
  public void init (Gpanel o) { // DNR
    setVars(o,tab,myW,myH,horizBoard); //DNC : init super class vars  
    owner.tab = tab; // DNC : give the default tab to Gplanel
    owner.horizBoard = horizBoard; // DNC : give the Board shape to Gplanel

    for (int i = 0; i < 7; i++) {
      billes[i] = getImage("m"+(i+1)+".gif");
    }
    pict = getImage("mancala.gif");
  } //end of init



  // paint 
  public void paintBoard( Graphics gr){
    // place the image in the center
    if (pict != null) {
      gr.drawImage(pict,0,0,this);
    } else {
      System.out.println("the picture is emtpy");
    }
    gr.setColor(Color.red);
    gr.setFont(rFont);
   
    for (int i = 0 ; i < 6 ; i++) {
      int cW = (i * bbP)  + bdW;
      doBol(i,cW +0, bbH +0, gr);
      doBol(12 -i,cW +0,bhH +0, gr);
    } 
    doBol(13,b13W + 0,(myH / 2)+0 , gr);
    doBol(6,b06W +0,(myH / 2) +0 , gr);
    
  }

  //doBol
  public void doBol(int bol,int x,int y, Graphics gr) {
    if ( (tab[bol] > 0) && (tab[bol] < 8)) { // 1 to 7 billes
      gr.drawImage(billes[tab[bol]-1],x - bD ,y - bD, this);
    }
    if ( tab[bol] > 7) {
      gr.drawImage(billes[6],x - bD ,y - bD, this);
      String value = ""+tab[bol];
      int width_V = rFM.stringWidth(value);
      gr.drawString(""+tab[bol],x-(width_V / 2) ,y+12 ); 
    }
  }

  //which bol is clicked
  public void getClickValue(int x,int y) {
    for (int i = 0 ; i < 6 ; i++) {
      int cW = (i * bbP)  + bdW ;
      int e = cW - bD;
      int w = cW + bD;
      int n = bbH + bD ;
      int s = bbH - bD ;
      if ((x > e) && (x <w) && (y < n) && (y > s)) {
	owner.play(i);
      }
    }
  }
}
















