
/**
 * Pbox
 * usage Pbox(Frame frame,String whocom,boolean modal)
 * Game requirement Dialog box
 * This is opensource software
 * @version 1.0b1 23/04/98
 * @author Pierre-Mikael Legris (plegris@fbwww.epfl.ch)
 */ 

import java.awt.*;
import java.util.StringTokenizer;

class Pbox extends Dialog
{
  private Button yes;
  private Button no;
  private TextField entry = new TextField( 20 ); 
  private String nick;
  private String game;
  private String comment;
  Wpanel parent;

  //constructor
  Pbox(Frame frame,String whocom,boolean modal) {
    super(frame,whocom,modal);
    parent = (Wpanel)frame;
    StringTokenizer st = new StringTokenizer(whocom,">");
    if (st.countTokens() == 3) {
      this.nick = st.nextToken();
      this.game = st.nextToken();
      this.comment = st.nextToken();
    } else {
      this.hide();
      this.dispose();
    }
    this.resize(250, 250);
    setTitle(nick);

    yes = new Button("Yes");
    no = new Button("No");
    
    setLayout(new GridLayout(6,1,2,2));
    add(new Label(""+nick+" wants to play with you. Accept?"));
    add(new Label("game: "+game));
    add(new Label("msg: "+comment));
    add(new Label("Enter a message below"));
    add(entry);
    Panel butts = new Panel();
     butts.setLayout(new GridLayout(1,2,1,1));
     butts.add(yes);
     butts.add(no);
    add(butts);
    repaint();

    Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
    move((d.width - this.size().width) / 2,(d.height - this.size().height) / 2); 

  }

  //Send Response
  public void respond(String r) {
    String inText = entry.getText();
    if (inText.compareTo("") == 0) { inText = "no comment" ; }
    inText = inText.replace('<','\\');
    inText = inText.replace('>','/');  
    parent.send("A<"+nick+">"+r+">"+inText);
     die();
  }

  // die
  public void die() {
    this.hide();
    this.dispose();  
  }

  //Handle event
  public boolean action(Event ev, Object obj) {
    // ok
    if (ev.target == yes) {
      respond("Y");
      return true;
    }
    // cancel 
    if (ev.target == no) {
      respond("N");
      return true;
    }
    return true;
  }
}// About
  










