import java.awt.*;
import java.net.*;

/**
 * Pict: A usefull class that loads pictures and return a Canvas 
 * <PRE>
 * This is to be used for adding simple images decorations into the GUI
 * Call it using: Canvas Picture = new Pict (name,width,height)
 * </PRE>
 *
 * @version 1.0 26/02/99
 * @author Pierre-Mikael Legris (plegris@fbwww.epfl.ch)
 */

class Pict extends Canvas { 
    Dimension mysize ;
    Image pict = null;

    public Pict () { }
    
    public Pict (String image,int w,int h) {
	super();
	mysize = new Dimension(w,h);
	pict = getImage(image);
	repaint();
    }
    
    public void paint(Graphics g) { 
	g.drawImage(pict,0,0,this);
    }
    
    public Image getImage(String imageName) {
	URL tempURL = null;
	Image tempImage = null;
	try {
	    tempURL = new URL(jGDK.base+imageName);
	    tempImage =  getToolkit().getImage(tempURL);
	} catch( MalformedURLException e ) {
	    System.out.println("image URL is bad "+ e);
	}
	System.out.println("downloaded "+tempURL);
	return tempImage;
    }


    /**
     * This is just needed
     */
    public Dimension minimumSize() {
	return mysize;
    }
    
    /**
     * This is just needed
     */
    public Dimension preferredSize() {
	return minimumSize();
    }
}       
    
