
import java.awt.*;
import java.util.StringTokenizer;
import java.util.Hashtable;

/**
 *@see Login 
 *@author Pierre-Mikael Legris (plegris@fbwww.epfl.ch)
 */ 
public class Wpanel extends Frame implements Runnable {

  // UI vars
  TextArea status = new TextArea(30 , 20);
  Label header = new Label("waiting room",Label.CENTER);
  Label infos = new Label("Jgames by Perki",Label.CENTER);
  List ulist = new List( 25 , false );        
  List glist = new List( 4 , false );
  Dimension myDim = new Dimension(550,400);

  // vars
  private Thread p; 
  Wplayer player = null;
  Hashtable userl = new Hashtable(); 
  Hashtable gamel = new Hashtable();
  Font uliF = new Font("courrier", Font.PLAIN , 10);
  FontMetrics uFM = getFontMetrics(uliF);
  int l = 398;
  boolean lfixed = false;

  // constructor
  public Wpanel(Wplayer human) {
    
    this.player = human;
    Thread p = new Thread(this);
    p.start(); 
  }

  //run
  public void run() {
    System.out.println("Wpanel started " + player.getNick());
    makeUI();
    String r;
    while(player.isAlive() && (! player.playing())) {
      try {
	r = player.read();
	if (r.compareTo("") != 0) { ParseS(r) ; }
      } catch(Exception e){ }
      try{ Thread.sleep(100); } catch(InterruptedException e){ } 
    }
    if (! player.isAlive()) {
      Ebox tell = new Ebox(this,"* disconected *",true);
      tell.show(true);
      dispose();
    }
  }
  
  
  /**
   * Parse the string and do what's needed
   */
  public void ParseS(String text) {    
    StringTokenizer st = new StringTokenizer(text,"<");
    if (st.countTokens() == 2) {
      char commande = st.nextToken().charAt(0);
      switch(commande) {
      case 'L': //userlist
	uli(st.nextToken());
	break;
	
      case 'G': //game list
	gli(st.nextToken());
	break;

      case 'J': //user join
	String who = st.nextToken();
	userl.put(who,"");
	break;

      case 'U': //user update
	updUser(st.nextToken());
	break;
      
      case 'Q': //user quit
	String whoo = st.nextToken();
	String val = (String) userl.get(whoo);
	removeItem(val);
	userl.remove(whoo);
	print("* "+whoo+" left");
	break;
	
      case 'A': //Playing reply
      case 'C': //Connecting reply
	StringTokenizer st2 = new StringTokenizer(st.nextToken(),">");
	if (st2.countTokens() > 1) {
	  char com2 = st2.nextToken().charAt(0);
	  switch(com2) {
	  case 'N': // error
	    Ebox tell = new Ebox(this,st2.nextToken(),true);
	    tell.show(true);
	    break;
	  case 'W': // wait
	    infos.setText(st2.nextToken());
	    break;
	  case 'Y': // start game
	    if (st2.countTokens() == 3) {
	      startGame(st2.nextToken(),st2.nextToken(),st2.nextToken());
	    }
	    break;
	  }
	}
	break;

      case 'Z': //Game reply
	StringTokenizer st3 = new StringTokenizer(st.nextToken(),">");
	if (st3.countTokens() > 1) {
	  char com2 = st3.nextToken().charAt(0);
	  switch(com2) {
	  case 'N': // refuse
	    infos.setText("choose someone to play with");
	    Ebox tell = new Ebox(this,"Game refused : "+st3.nextToken(),true);
	    tell.show(true);
	    break;
	  case 'Y': // start game
	    if (st3.countTokens() == 3) {
	      startGame(st3.nextToken(),st3.nextToken(),st3.nextToken());
	    }
	    break;
	  }
	}
	break;

      case 'R': //Do you want to play with?
	Pbox tell = new Pbox(this,st.nextToken(),true);
	tell.show(true);
	break;

      case 'S': //Server message
	print(st.nextToken());
	break;
      }
    }
  }

  
  /**
   * User Update
   */
  public void updUser(String user) {
    StringTokenizer st = new StringTokenizer(user,">");
    if (st.countTokens() == 4) {
      String who = st.nextToken();
      String val = (String) userl.get(who);
      String nval = uformat(who,st.nextToken(),st.nextToken(),st.nextToken());

      if (val.compareTo("") == 0) { 
	// user join
	userl.put(who,nval);
	ulist.addItem(nval);
	print("* "+who+" joined");
      } else {
	// detect the position of the user in the list an update it
	int ull = ulist.countItems();
	for (int i = 0 ; i < ull ; i++) {
	  String test = ulist.getItem(i);
	  if (val.compareTo(test) == 0 ) {
	    ulist.replaceItem(nval,i);
	    userl.put(who,nval);
	    break;
	  }
	}  
      }
    }
  }

  
  /**
   * remove a nick from the list
   */
  public void removeItem(String val) {
    int ull = ulist.countItems();
    for (int i = 0 ; i < ull ; i++) {
      String test = ulist.getItem(i);
      if (val.compareTo(test) == 0 ) {
	    ulist.delItem(i);
      }
    }
  }

  
  /**
   *Start Game
   */
  public void startGame(String withWho,String game,String message) {
    player.setPlay(withWho);
    Gpanel gamePanel = new Gpanel(this,player,message,game);
    infos.setText("* game started *");
  }

  /**
   * GameList creator
   */
  public void gli(String games) {
    glist.addItem("Perki");
    glist.clear();
    gamel.clear();
    StringTokenizer st = new StringTokenizer(games,"#");
    while(st.hasMoreTokens()) {
      StringTokenizer st2 = new StringTokenizer(st.nextToken(),":");
      if(st2.countTokens() == 2) {
	String gameK = st2.nextToken();
	glist.addItem(gameK);
	StringTokenizer st3 = new StringTokenizer(st2.nextToken(),",");
	if(st3.countTokens() == 3) {
	  String temp = st3.nextToken(); 
	  temp = st3.nextToken();
	  gamel.put(gameK, st3.nextToken());
	} else {
	  gamel.put(gameK, "unknown");
	}
      }
    }
  }

  
  /**
   * UserList creator
   */
  public void uli(String users) {
    ulist.addItem("Perki");
    userl.clear();
    cleanUI();
    StringTokenizer st = new StringTokenizer(users,">");
    while (st.hasMoreTokens() && (st.countTokens() > 3)) {
      String key = "";
      String val = "";
      key = st.nextToken();
      val = uformat(key,st.nextToken(),st.nextToken(),st.nextToken());
      userl.put(key,val);
      ulist.addItem(val);
    }
  }

  
  /**
   * UserList string formater
   */
  String uformat(String nic,String com,String from,String play) {
    if (! lfixed) {
      l = ulist.size().width ;
      lfixed = true;
    }
    int m = uFM.stringWidth("MMMMMMMM");
    int c = l - ( 2 *  m ) - 40 ; 
    nic = normalize(nic, m + 5);
    com = normalize(com, c + 5);
    play = normalize(play, m );
    return nic+com+play;
  }

  
  /**
   * String normalizer
   */
  String normalize(String text,int max) {
    String tmp = "";
    if ( uFM.stringWidth(text) > max ) {
      for (int i = 0; uFM.stringWidth(tmp) < max ; i++ )
	tmp = tmp + text.substring(i  , i + 1);
    } else {
      tmp = text;
    }
    while ( uFM.stringWidth(tmp) < max ) 
      tmp = tmp + " ";
    tmp = tmp + " ";
    return tmp;
  }

  // Status writer
  public void print(String text) {
    status.appendText(text + "\n");
  }

  // Player writer
  public void send(String text) {
    player.send(text);
    if (! player.isAlive()) {
      cleanUI() ;
      print("* disconected");
      infos.setText("* disconected *");
    }
  }

  // clean UI
  public void cleanUI() {
    ulist.clear();
    ulist.addItem(uformat("NICK","COMMENT","FROM","PLAYING"));
  }
  
  
  // make UI
  public void makeUI() {
    status.setEditable( false );
    setLayout(new BorderLayout());
    header.setFont(new Font("Helvetica", Font.BOLD , 13));
    header.setBackground(Color.blue);
    header.setForeground(Color.white);
    infos.setBackground(Color.yellow);
    ulist.setBackground(Color.white);
    status.setBackground(Color.white);
    glist.setBackground(Color.white);
    ulist.setFont(uliF);
    glist.setFont(uliF);
    
    Panel east = new Panel();
     east.setLayout(new BorderLayout());
     east.add("Center",status);
     east.add("North",glist);

    add("North",header);
    add("Center",ulist);
    add("South",infos);
    add("East",east);
    header.setText("waiting room    :"+player.getNick());

    resize(myDim.width,myDim.height);
    repaint();
    if ( ulist.size().width < 390 ) {
      ulist.resize(390,ulist.size().height);
      // repaint();
    }
    show(true);
  }
  
  // handleEvent
  public boolean handleEvent(Event evt) {
    // click on the userlist
    if ((evt.target == ulist) && (evt.id == 701 )) {
      String gameN = glist.getSelectedItem();
      if (gameN == null) { //no game is selected
	Ebox er = new Ebox(this,"please choose a game",true);
	er.show(true);
      } else { // ok a game is selected
	String whoi =  ulist.getSelectedItem();
	StringTokenizer st2 = new StringTokenizer(whoi);
	if (whoi != null ) 
	  {
	    Abox ask = new Abox(this,st2.nextToken()+" "+gameN,true);
	    ask.show(true);
	  }
      }
      return true;
    }
    
    // close the windows
    if (evt.id == Event.WINDOW_DESTROY) {
      player.die();
      dispose();
    }
    return super.handleEvent(evt);
  }
  
}





















