import java.awt.*;
import java.applet.*;
import java.applet.Applet.*;
import java.net.*;
/**
 *<B>Gpanel:</B> for the jGDK
 * <PRE >
 * Gpanel is the UI of the human board game
 * </PRE>
 *@see Login 
 *@author Pierre-Mikael Legris (plegris@fbwww.epfl.ch)
 */ 
public class Gpanel extends Frame  {
  // UI vars

    
    Label header = new Label("DK for jGAMES",Label.CENTER);
    Label move = new Label("MOVE");
    TextField chat = new TextField(); 
    Button stop = new Button("REPLAY");
    Button sound = new Button("UNUSED");
    Font defFont = new Font("Helvetica", Font.PLAIN , 12);
    Board gameBoard ;
    int tab[] ; 
    
    boolean horizBoard = true;
    private boolean myTurn = true;
    Dimension myDim = new Dimension(630,400);  
    String myName;
    Hplayer owner;
    
   
    // constructor
    public Gpanel(String game,Hplayer owner) {
	this.owner = owner;
	setTitle("DK for jGame");
	try {
	    gameBoard = (Board) Class.forName(game).newInstance();
	} catch(Exception e) {
	    System.out.println(e);
	}
	
      gameBoard.init(this);
      
       
      
      makeUI();
      this.show();
         
     
    }
    
 
  
    //play : player clicked on a bol
    public void play(int bol) {
	if ( myTurn ) {
	  owner.play(bol);
	}
    }
    
    //setName
    public void setName(String name) {
	myName = name;
    }

    public boolean getTurn() { return myTurn; } 
    
    public void setTurn(boolean turn) { 
	
	this.myTurn = false;
	if (turn) { 
	    this.myTurn = true ;  
	} 
	if (myTurn) {
	    //move.setText("PLAY");
	    move.setBackground(Color.green);
	} else {
	    //move.setText("WAIT");
	    move.setBackground(Color.red);
	}
	
    }

    //setTurn
    public void setTurn(boolean turn, int[] ttab) {
	System.out.println("G "+this.myTurn+" "+turn);
	setTurn(turn);
	for (int i = 0; i < ttab.length ; i++)
	    gameBoard.tab[i] = ttab[i];

	gameBoard.repaint();
    }

    public void print(String text) {
	move.setText("   "+text);
    }
  
    // make UI
    public void makeUI() {
	setLayout(new BorderLayout());
	setBackground(Color.white);
	header.setFont(new Font("Helvetica", Font.BOLD , 13));
	
	//header.setBackground(Color.blue);
	//header.setForeground(Color.white);

	
	Panel middle = new Panel();
	middle.setLayout(new BorderLayout());
	middle.add("Center",gameBoard);
	
	add("Center",middle);
	
	Panel bottom = new Panel();
	bottom.setLayout(new BorderLayout());
	
	bottom.add("East",stop);
	bottom.add("Center",header);
	bottom.add("South",move);
	bottom.add("West",sound);
	add("South",bottom);
	
	header.setText("header");

	resize(myDim.width,myDim.height); 
	gameBoard.repaint();
	repaint();
	show(true);
    }
    
    public void die() {
	 
	 dispose();
	 System.exit(1);
	
    }
    
    // handleEvent
    public boolean handleEvent(Event evt) {
	if (evt.id == Event.WINDOW_DESTROY) {
	   die();
	}   
	return super.handleEvent(evt);
    }
    
    // handle actions
    public boolean action(Event e, Object o)
    {
	 if (e.target == stop) {
	     owner.init();	    
	 }         
	
	 
	return true;    
    }

   
    
    public void win(boolean did) {		
	owner.init();
	move.setText("YOU HAVE LOST");
	if (did) {
	    move.setText("YOU WIN");
	}
    }
      
}

















