
// MRules
/**
 * usage: MRules(String player1)<BR>
 * See if the move is ok and determine if the player can move again
 *
 *<PRE>
 * The way to call the rules method: verif replay move and win
 * method(int bol, String player) for the server
 * like this Rules can invert the table or not
 *</PRE>
 */

public class MRules extends Rules
{
  /**
   * initialisation des variables
   */
  public int tab[] = new int[14];

  /**
   *constructor
   */
  public MRules () { 
    newGame();
  }

  
  //*** here are the rules ***

  /**
   * init the board
   */
  public void newGame() {
    super.tab = tab;
    for (int i = 0 ; i < 13 ; i ++) { tab[i] = 4 ; }
    tab[13] = 0; tab[6] = 0;
  }

  /**
   * move
   */
  public int[] m(int bol,int[] ttab) {
    //get the last bol 
    int lastBol = bol + ttab[bol];
    while(lastBol > 12) {
      lastBol = lastBol - 13; 
    }

    //empty the first bol and fill the others
    int n = ttab[bol];
    ttab[bol] = 0;
    for( int i = bol ; i < (bol + n) ; i++ ) {
      int j = i + 1;
      while ( j > 12) { j = j - 13 ;}
      ttab[j]++;
    }
    
    // if last bol was empty get the values in 6
    if ((ttab[lastBol] == 1) && (lastBol < 6) && (ttab[12 - lastBol] > 0)) {
      ttab[6] = ttab[6] + ttab[12 - lastBol] + 1;
      ttab[lastBol] = 0;
      ttab[12 - lastBol] = 0;
    }
    
    // if no more moves all goes to the other
    for (int j = 0; j <8 ; j = j + 7) {
      boolean empty = true;
      for( int i = j ; i < (6 +j) ; i ++) {
	if( ttab[i] != 0 ) { empty = false; }
      }
      if (empty ) {
	for (int i = (7 -j) ; i < (13 -j); i ++) {
	  ttab[(13 -j)] = ttab[(13 -j)] + ttab[i];
	  ttab[i] = 0;
	}
      }
    }
    
    
    return ttab;
  }

  /** 
   * return true if the player can replay
   */
  public boolean r(int bol,int[] ttab) {
    //get the last bol
    int lastBol = bol + ttab[bol];
    while(lastBol > 12) { lastBol = lastBol - 13; }
    if (lastBol == 6) { 
      return true;
    } else {
      return false;
    }
  }

  /**
   * win, loose , tie
   */
  public int w(int[] ttab) {
    if (ttab[6] > 24) {
      return 1 ; // player win
    } 
    if (ttab[13] > 24) {
      return 2 ; // player loose
    } 
    if (ttab[6]==24 && ttab[13]==24) {
      return -1; // tie
    }
    return 0; 
  }
  
  /**
   * is this move valid?
   */
  public boolean v(int bol,int[] ttab) {
    if ( (bol > -1) && (bol < 6)) {
      if (ttab[bol] != 0) {
	return true;
      } else {
	return false;
      }
    } else {
      return false;
    }
  }
  
  /**
   * reverse the table
   */
  public int[] rtab(int[] stab) {
    int[] ntab = new int[14];
    for (int i = 0; i < 7 ; i++ ) {ntab[i + 7] = stab[i]; }
    for (int i = 7; i < 14 ; i++ ) { ntab[i - 7] = stab[i];  }
    return ntab;
  }

 
  /**
   * message to send to this player
   */
  public String msg(int bol,boolean p) {
    if (p) {
      return "You played bol "+(bol+1);
    }
    else return "Opponent played bol "+(bol +8);

  }
 
}






