/**
 * <B>Mbot</B> Robot
 * <PRE>
 * Mbot est soit appele par Mancala soit par Tournoi il joue lorsqu'il
 * recoit l'instruction setTurn(true)
 * </PRE>
 * @version 1.0b1 8 Mai 98
 * @author Pierre-Mikael Legris (plegris@fbwww.epfl.ch) & Patrick Mayer (pmayer@fbwww.epfl.ch)
 */
public class Mbot extends Player {
  String myNick = "";
  String info = "-";
  int tab[] = new int[14];
  int badTab[][] = {{1,2,8,7,6,6,1,4,4,0,5,0,1,3,3},
		    {2,2,11,1,7,0,6,0,2,2,2,1,0,12,3},
		    {0,0,12,0,8,0,9,0,0,1,3,0,0,15,2},
		    {1,2,1,2,9,0,10,0,4,3,0,1,0,15,3},
		    {2,3,9,1,7,7,2,5,0,2,0,2,1,7,1},
		    {3,2,0,1,0,0,9,3,0,3,2,4,4,17,1},
		    {0,4,1,0,1,0,13,0,3,1,14,2,0,9,1},
		    {0,1,1,0,0,0,20,2,4,0,2,0,0,18,2},
		    {1,1,3,2,3,0,14,0,5,3,1,0,0,15,0},
		    {3,1,3,0,4,3,16,2,2,0,1,1,1,11,0},
		    {0,0,2,2,4,0,16,2,2,1,0,11,0,8,2}
		    };
  
  /**
   * Constructor, DO NOT CHANGE
   **/
  public Mbot () {  
    super("Mbot","Mancala robot",true);
  }

  
  synchronized public int play(int ntab[]) {
    this.tab = ntab;
    return strat();
  }

  
  /**
   * cette methode choisie le meilleur coup a jouer et
   * retourne le bol a jouer sout forme d'entier
   */
  int strat() {
    int j;
    for ( int i = 0; i < 11; i++) {
      j = checkBadTab(i);
      if ( j < 6 ) {  return j; }
    }
    j = terminer();
    if ( j < 6 ) {  return j; }
    j = captureOrNot();
    if ( j < 6 ) {  return j;}
    j = finDePartie();
    if ( j < 6 ) { return j;}
    j = emptyRightest();
    if ( j < 6 ) {  return j;}
    j = prepareSecondShot(); 
    if ( j < 6 ) { return j;}
    j = emptyBiggest();
    if ( j < 6 ) {  return j;}
    j = hasard();
    return j;
  }
  
  /**
   * Check Bad Tabs (reflex conditiones)
   * Pour certaines tables bien determinees 
   * il connait deja le meilleur coup
   */
  int checkBadTab(int j) {
    for (int i = 0; i < 14; i++) {
      if (tab[i] != badTab[j][i])
	return 8;
    }
    log("check Bad Tab "+j);
    return badTab[j][14];
  }

  /**
   * le methode terminer est appelee si l'ordinateur a 24 pions dans son 
   * kalaha et est donc en position de remporter la partie
   */
  int terminer() {
    int j = 6;
    if (tab[6] == 24) { 
      for ( int i = 0 ; i < 6; i++ ) {    
        if (tab[i] >= j) {
          log("terminer");
          return i;
        }
        j--;
      }
    }
    return 100;
  }

  /**
   * cette methode permet de tester si l'ordinateur est en mesure de jouer
   * un coup lui permettant de rejouer, c'est a dire la methode test si le 
   * dernier pion est pose dans le kalaha en comencant par la droite, de facon
   * a rejouer un maximum de fois
   */
  int rejouer(int ttab[]) {
    int j = 1;
    for ( int i = 5; i >= 0 ; i--) {
      int temp = ttab[i];
      if ( tab[i] > 13 ) {
        temp = ttab[i] - 13;
      }
      if (temp == j) {
        
        return i;
      }
      j++;
    }
    //log("rejouer");
    return 100;
  } 

  

   /**
   * Choisit entre capturer rejouer et avoidCapture en fonction du gain/perte
   */
  int captureOrNot() {
    int i = capture(tab); //bol qui permet de capturer
    int j = avoidCapture(); //bol qui pourrait etre capturer
    int k = rejouer(tab); //bol qui permet de rejouer
    int gainR = howManyR(tab);
    
    // capture
    if ( i < 6 && j > 6 && gainR==0) { log("capture"); return i; }
    // avoidCapture
    if ( i > 6 && j<6 && gainR==0) { log("avoid capture"); return bestAC(j); }
     // aucun des deux
    if ( i > 6 ) { log("rejouer"); return k; }

    int temp = 12-i-tab[i];  // bol a capturer
    while (temp < 0 ) { temp += 12; } // normalisation de temp
    int gainC = tab[temp]+1; // gain de la capture

    if (gainR == 0) { // pas de rejouer
      if (((gainC >= tab[j]+1) && (tab[13]+tab[j]+1 < 25)) || (gainC+tab[6]>24)){
	log("captureOrNot capturer");
	return i;
      } else {
	return bestAC(j);
      }
    } else { // rejouer ou capturer
      if ( k > (i+tab[i]) ) { // le rejouer ne gene pas la capture
	log("rejouer sans gene");
	return k;
      } else {
	if ( gainC >= gainR ) { // il vaut mieux capturer que rejouer
	  log("rejouerOrNot capturer");
	  return i;
	} else { // il vaut mieux rejouer que  capturer
	  log("rejouerOrNot rejouer");
	  return k;
	}
      }
    }
  }


  /**
   * regarde si en jouant un ce coup il pourrait rejouer le coup suivant
   * en essayant d'en mettre un dans le Kalaha
   */
  int prepareSecondShot() {
    int bol = 8;
    for ( int i = 4 ; i < 6 ; i++ ) {
      int nbT = 1;
      if ( tab[i] > 13 ) { nbT = 2; }
      if ( tab[i] == 6 - i - nbT ) { 
        for ( int j = i-1 ; j >= 0 ; j-- ) {
          if ( tab[j] + j >= i ) {
	    if ( bol > 6) {
	      bol = j;      
	    }
	    if ( tab[j] + j > 5) {
	      log("prepare second tour +++");
	      return j;
	    }   
          }
        }
      }
    }
    if ( bol < 6) {
      log("prepare second tour simple");
    }
    return bol;
  }
  
  /**
   * vide le plus gros des bol qui lui permet de jouer dans le kalaha
   */
  int emptyBiggest() {
    int max = 0;
    int maxBol = 8;
    for ( int i = 5; i >= 0; i-- ) {
      if ( (tab[i] > max) && ((tab[i] +i) > 5) ) {
        max = tab[i];
	maxBol = i;
      }
    }
    return maxBol;
  }

  /**
   * vide le bol le plus a droite
   */
  int emptyRightest() {
    if ( tab[5] != 0 ) {
      log("vide le tout a droite");
      return 5;
    }
    return 100;
  }  
  
  /**
   * choisit un bol au hasard 
   */
  int hasard() {
    int h; 
    int z = 0;
      do {
	z++;
	h = (int) ( Math.random() * 6);
	if (z > 20) {break;}
      } while ( tab[h] == 0) ;
    log("hasard");
    return h;
  }

  /****************************************************/
  // les methodes ci-dessous sont utilisees par les strategies

  /**
   * retourne le dernier bol ou arrive la bille
   **/
  int getlastBol (int bol,int ttab[]) {
    int lastBol = bol + ttab[bol];
    while(lastBol > 12) { lastBol = lastBol - 13; }
    return lastBol;
  }

  /**
   * Retourne le bol qui lui permet de capturer un maximum de billes
   * en commencant par la droite
   */
  int capture(int ttab[]) {
    int maxBol = 8;
    int maxBille = 0;
    for ( int i = 5 ; i >= 0; i-- ) {
      // si il y a moins de 14 billes dans ce bol et qu'il n'est pas vide
      if ((ttab[i] < 14) && (ttab[i] != 0)) { 	
	int lastBol = getlastBol(i,ttab);
	if (lastBol < 6 ) { // un de mes bol
	  int gain = ttab[12 - lastBol];
	  if ((ttab[lastBol] == 0) && ( gain != 0)) 
	    { // mon bol est vide et celui de l'autre ne l'est pas
	      if (maxBille < gain) { // gain superieur
		maxBille = gain;
		maxBol = i;
	      }
	    }
	}
      }   
    }
    return maxBol;
  }
 
  /**
   * Calcul le bol que l'adversaire jouerait pour capturer une de nos bille
   */
  int avoidCapture() {
    int obol = capture(rtab(tab)) + 7; //bol que l'adversaire pourrait jouer
    if (obol > 12) { // l'adversaire ne peux pas jouer
      return 8;
    }
    
    int cbol = obol + tab[obol] ; //bol vide de l'adversaire
    while (cbol > 13) { cbol = cbol - 13; }
    int mbol = 12 - cbol; //bol que l'adversaire peut capturer
    
    log("l'adversaire peut capturer le bol "+mbol);
    
    return (mbol);  
    
  }

  /**
   * calcul le meilleur coup a jouer pour eviter une capture
   **/
  int bestAC(int j) {
    //peut-on empeche la capture en en mettant dans dans notre kalaha
    for (int l = 0; l < 6; l++ ) {
      int obol = capture(rtab(tab)) + 7;
      if ( tab[l] + l >= (obol + tab[obol]) ) {
	  log("captureOrNot AVOIDcapture2");
	  return l;
      }
    }
    log("captureOrNot avoidCapture");
    return j;
  }

  /**
   * S'il ne reste plus que 2 bols non vides chez l'adversaire, l'ordinateur
   * va essayer de ne pas lui en remplir afin de le faire perdre ou que
   * la somme des pions de l'adversaire est < 4
   */
  int finDePartie() {
    int j = 0;                     
    int sumA = 0;
    for ( int i = 7; i < 13; i++) {
      sumA += tab[i];
      if ( tab[i] != 0 )
        j++;
    }
    if (( j < 3 && tab[7]<3 && tab[8]<3 && tab[9]<3) || sumA < 4 ) {
      for ( int i = 0; i < 6; i++) {
        if ( (tab[i] + i) < 7 && tab[i] != 0 ) {
          log("Fin de partie");
          return i;
        }
      }
    }
   
    return 100;
  }
  
  /**
   * Calcul le nombre de replay possible pour un tableau
   */
  int howManyR(int stab[]) {
    int ttab[] = new int[14];
    for (int i = 0;i < 14;i++) {
      ttab[i] = stab[i];
    }
    int compteur = 0;
    int coup = rejouer(ttab);
    while ( coup < 6 ) {
      compteur++;
      ttab = move(coup,ttab);
      coup = rejouer(ttab);
    }
    return compteur;
  }


  /**
   * distribution des pions dans les bons bols et retourne le nouveau tableau
   */
  int[] move(int bol,int[] stab) {
    int ttab[] = new int[14];
    for (int i = 0;i < 14;i++) {
      ttab[i] = stab[i];
    }
    //get the last bol 
    int lastBol = bol + ttab[bol];
    while(lastBol > 12) {
      lastBol = lastBol - 13; 
    }

    //empty the first bol and fill the others
    int n = ttab[bol];
    ttab[bol] = 0;
    for( int i = bol ; i < (bol + n) ; i++ ) {
      int j = i + 1;
      while ( j > 12) { j = j - 13 ;}
      ttab[j]++;
    }
    
    // if last bol was empty get the values in 6
    if ((ttab[lastBol] == 1) && (lastBol < 6) && (ttab[12 - lastBol] > 0)) {
      ttab[6] = ttab[6] + ttab[12 - lastBol] + 1;
      ttab[lastBol] = 0;
      ttab[12 - lastBol] = 0;
    }
    
    // if no more moves all goes to the other
    for (int j = 0; j <8 ; j = j + 7) {
      boolean empty = true;
      for( int i = j ; i < (6 +j) ; i ++) {
	if( ttab[i] != 0 ) { empty = false; }
      }
      if (empty ) {
	for (int i = (7 -j) ; i < (13 -j); i ++) {
	  ttab[(13 -j)] = ttab[(13 -j)] + ttab[i];
	  ttab[i] = 0;
	}
      }
    }
    
    
    return ttab;
  }

   /**
   * inverse le tableau de jeu, cette fonction permet de s'implifier 
   * l'implementation du programme
   */
  int[] rtab(int[] stab) {
    int[] ntab = new int[14];
    for (int i = 0; i < 7 ; i++ ) {ntab[i + 7] = stab[i]; }
    for (int i = 7; i < 14 ; i++ ) { ntab[i - 7] = stab[i];  }
    return ntab;
  }

  /**
   * Centralise le log de Mbot
   */
  void log(String s) {
    // System.out.println("Mbot "+s);
  }
 
  
}






