import java.awt.*;  //DNC       

/**
 * TBoard
 * TicTacToe Board
 * <PRE>
 * this file is designed to be an example for creating games for jGames
 * -the comment "DNR" (do not remove) means that this method or variable 
 *  musn't be removed but should be changed to fit the game you are coding
 * -the comment "DNC" (do not change) means that this method or variable
 *  must be there and left as it's.
 *-
 *-
 * if TBoard is an extension of Board it's because I included some "tools"
 * in Board that are usefull to build a game, and like this, there is no 
 * need to rewrite or copy those methods.
 * * tool list
 * * hidden tools
 * 1- Board do the translation between absolut coordinates and image
 *    like this you don't have to bother about the position of your board.
 *    (see tW(),tH(), mouseDown() and paint() )
 * 2- Board do all the double buffering thing which avoid the image to
 *    flicker. 
 *    (see update() and paint())
 *-
 * * not hidden tool
 * getImage(String name) will return you an image from the directory where
 *  the applet was downloaded
 * </PRE>
 * @version 1.0b1 25/04/98
 * @author Pierre-Mikael Legris (plegris@fbwww.epfl.ch)
 */
class TBoard extends Board { //DNR, Change "TBoard" to the name of your class

  // ** The folowing variables int values can be changed
  
  /** Array that gives the start board */
  int tab[] = {0,0,0,0,0,0,0,0,0};  //DNR
  /** width of the board (in this case width of the picture I use) */
  int myW = 200; //DNR  
  /** heigth of the board */
  int myH = 200; //DNR  
  /** if you want the Board to be horizontal set this to true */
  boolean horizBoard = true; //DNR 
  
  // ** Vars for the game TicTacToe
  /** this is the width of a cross picture divided by 2 */
  int crossd = 25;
  /** the array in which I'll store images 0 for background 
   * 1 for player's crosses 2 for opponent crosses */
  Image picts[] = new Image[3]; 


  /**
   * Constructror
   */
  public TBoard() { } // DNC

  /**
   * initialization of the Board
   * this method is called only once, at the start of the Game.
   */
  public void init (Gpanel o) { // DNR
    setVars(o,tab,myW,myH,horizBoard); //DNC : init super class vars
    owner.tab = tab; // DNC : give the default tab to Gplanel
    owner.horizBoard = horizBoard; // DNC : give the Board shape to Gplanel

    // *** IMAGES DOWNLOADING START ***
    // Here we start retriving the images, if you don't have images
    //  you can remove the folowing lines

    for (int i = 0; i < 3; i++) { // loop to get the 3 pictures
      // ttt0.gif is the background ttt1.gif the cross for this player 
      // and ttt2.gif for the opponent. 
      picts[i] = getImage("ttt"+(i)+".gif"); //retreiving images
    }
    // *** IMAGES DOWNLOADING STOP ***
    
  } //end of init

  
  /**
   * this method is each time the player receive 
   * a new array representing the game Board.
   * this is where you draw a new board.
   *
   * gr is the Graphics on which you will draw, it's automgically double
   * buffered and centered on the player's Frame
   */
  public void paintBoard(Graphics gr){ // DNR
    
    // there I draw my background. Change this if you have images
    gr.drawImage(picts[0],0,0,this);
   
    // draw crosses ; tab is the last array representing the Board.
    for (int i = 0 ; i < 3 ; i++) { // i represent columns
      for (int j = 0 ; j < 3 ; j++) { // j represent raws
	// (i+3*j) is the position in the array for this cross
	int cross = tab[i+3*j]; 
	if (cross != 0) { // if this square is checked
	  // x is the left reference for the cross
	  int x = 33 + 67 * i - crossd ; 
	  // y is the top reference for the cross
	  int y = 33 + 67 * j - crossd ; 
	  // draw the image that goes with this cross value
	  gr.drawImage(picts[cross],x,y,this); 
	}
      }
    }// end of draw crosses
  }// end of paint()


  /**
   * This method is called by mouseDown() each time a bol is clicked.
   * It determine on which square the player clicked, 
   * and gives the position in the  array of this clicked 
   * square to owner.play() .
   * xC and yC represents the coordinates in the Image you draw in
   * paintBoard(Graphics gr);
   */
  public void getClickValue(int xC,int yC) { //DNR
    
    for (int i = 0 ; i < 3 ; i++) { // i represent columns
      for (int j = 0 ; j < 3 ; j++) { // j represent raws
	// is the position in the array of this square
	int square = i+3*j ;
	// x is the left reference for the center  of the square 
	int x = 33 + 67 * i ; 
	// y is the top reference for the center of the square 
	int y = 33 + 67 * j ; 
	int w = x - 33 ; // West limit of this square 
	int e = x + 33 ; // East 
	int s = y + 33 ; // South
	int n = y - 33 ; // North
	// ok we are in this square
	if ((xC > w)&&(xC < e)&&(yC < s)&&(yC > n)) { 
	  owner.play(square); //DNR ; well now we send that to Gpanel 
	} 
	
      }
    }
  }   
} // well now it's your turn to build a game ... have fun!
















