
/**
 * TRules
 * TicTacToe Rules
 * <PRE>
 * this file is designed to be an example for creating games for jGames
 * -the comment "DNR" (do not remove) means that this method or variable
 *  musn't be removed but should be changed to fit the game you are coding
 * -the comment "DNC" (do not change) means that this method or variable
 *  must be there and left as it's.
 *
 * Each of the folowing methods works for one player only, that's why you need 
 * to write a rtab() method that reverse the table if the player who is playing
 * isn't player1.
 *
 * all the calls to thoses methods are done from Rules.java 
 *
 * </PRE>
 * @version 1.0b1 25/04/98
 * @author Pierre-Mikael Legris (plegris@fbwww.epfl.ch)
 */              
public class TRules extends Rules  {//DNR, Change "TRules" to the name of your class 
  /**
   * tab is where the game is saved, this array represent player1's  board
   *
   * where 0 values are unchecked squares , 1 player1's crosses and 2 for player 2.
   */
  public int tab[] = new int[9]; // DNR; 

  /**
   *constructor 
   */
  public TRules () { //DNC 
    newGame();
  }
  
  //*** here are the rules ***

  /**
   * init the board
   */
  public void newGame() { // DNR: this where the board is initialised when a new game start
    super.tab = tab; //DNC

    
    for (int i = 0 ; i < 9 ; i ++) { tab[i] = 0 ; }
  }

   /**
   * reverse the array, this is used as m(),v(),r() works only for 1 player
   * so we reverse the array each time player2 plays
   */
  public int[] rtab(int[] stab) { //DNR
    int[] ntab = new int[9];
    for (int i= 0; i < 9; i++) {
      ntab[i] = 0;
      if ( stab[i] == 1 ) { ntab[i] = 2 ; } // I just switch 1 to 2 and 2 to 1
      if ( stab[i] == 2 ) { ntab[i] = 1 ; } // as 1 represent player's 1 crosses
    }
    return ntab;
  }
  
  /** 
   * return true if this move is valid
   */
  public boolean v(int i,int[] ttab) { //DNR
    return (ttab[i] == 0); // if it's unchecked
  }

  /** 
   * return true if the player can replay
   */
  public boolean r(int bol,int[] ttab) { //DNR
    return false; // players never replay at TicTacToe
  }

  /**
   * move, this method is called by move() it returns a new array 
   * for this move at this position on this board as if the paler was player 1
   */
  public int[] m(int i,int[] ttab) { //DNR
    ttab[i] = 1;
    return ttab;
  }

 
  /**
   * win, loose , tie
   * return 0 if not finished
   * 1 if this player win
   * 2 if the opponent win
   * -1 if it's a tie
   */
  public int w(int[] ttab) { //DNR
    //for the game TicTacToe a move can't make the opponent win 
    // so I won't check for it neither return 2
    
    //check horizontals 
    for (int i=0; i < 9; i += 3) {
      if ( ttab[i]==1 && ttab[i+1] == 1 && ttab[i+2] == 1) {
	return 1;
      }
    }
    
    //check verticals
    for (int i=0; i < 3; i++) {
      if ( ttab[i]==1 && ttab[i+3] == 1 && ttab[i+6] == 1) {
	return 1;
      }
    }
    
    //check diagonals
    if ( ttab[2]==1 && ttab[4] == 1 && ttab[6] == 1) {
      return 1;
    }
    if ( ttab[0]==1 && ttab[4] == 1 && ttab[8] == 1) {
     return 1;
    } 
    
    //check tie
    for (int i=0; i < 9; i++) {
      if ( ttab[i] == 0 ) {
	return 0; // still an empty square
      }
    }
    
    //no tie no winner and there isn't anything to check 
    return -1; 
  }
  

  /**
   * message to send a player when he plays something
   * if p = true that does mean it's for the player and false for the oponnent
   */
  // well obviously TicTacToe isn't a good example
  // for this one. Have a look to Mancala's rules
  // which have a better use of this
  public String msg(int bol,boolean p) { //DNR
    if (p) {                    
      return "You played";      
    }                          
    else return "Opponent played";
  } 
}












