
import java.awt.*;

/**
 * <B>jGDK</B> Usage: java jGDK <letter(s)> <h|b> <h|b> 
 * <PRE>
 * If you want to test a robot class called Mbot.class 
 * a Human board called MBoard.class and a rule called MRules.class
 * use: java jGDK M h b
 * 
 *  This is the jGames Developement Kit
 *  It's designed to test Robots, Board and Rules classes for jGames
 *
 * This class needs it's own  Gpanel.class  Player.class and HPlayer.class
 * It alse needs Rules.class and Board.class but they are similar to
 * the client's and the server's ones
 * </PRE>
 * @version 1.0b1 5 Feb 99
 * @author Pierre-Mikael Legris (plegris@fbwww.epfl.ch) 
 */
public class jGDK
{
    
  Player player1;
  Player player2; 
  Rules rules;
  private boolean turn = true;
 
  public static void main(String args[])
    {
	
	if (args.length != 3) {
	    System.out.println("java jGDK <letter(s)> <h|b> <h|b>\nIf you want to test a robot class called Mbot.class \na Human board called MBoard.class and a rule called MRules.class \nuse: java jGDK M h b");
	    
	    System.exit(1);
	} 
	jGDK game = new jGDK(args);
    }


  /**
   *Constructeur, cree les deux joueurs ainsi que la regle puis lance un Thread jGDK
   */
    public jGDK(String args[]) {
	String l = args[0];
	try {
	    rules = (Rules) Class.forName(l+"Rules").newInstance();
	    
	    if (args[1].equals("h")) {
		player1 = new Hplayer();
		player1.setName(l+"Board","1"); 
	    } else {
		player1 = (Player) Class.forName(l+"bot").newInstance();
		player1.setName("1");
	    }

	    if (args[2].equals("h")) {
		player2 = new Hplayer();
		player2.setName(l+"Board","2");  
	    } else {
		player2 = (Player) Class.forName(l+"bot").newInstance();
		player2.setName("2");
	    }

	    } catch(Exception e) { 
		System.out.println(e); 
		System.exit(1);
	    }
	rules.setName1("1"); 
	
	player2.setOwner(this);
	player1.setOwner(this);
	
	init();
    } 
    
    public void init () {
	rules.newGame();
	player1.print("New Game started");
	player2.print("New Game started");
	if (! turn) {
	    player1.setTurn(false,rules.getTab("1"));
	    player2.setTurn(true,rules.getTab("2"));
	} else {
	    player2.setTurn(false,rules.getTab("2"));
	    player1.setTurn(true,rules.getTab("1"));
	}
	turn = !turn;
    }


    /**
     * log : just print a text on the console
     */
    void log(String s) {
	System.out.println(s);
    }

    synchronized void play(int i,Player player) {
	boolean replay = false;
	Player opponent;
	String name = player.getName();
	
	if (name.equals(player1.getName())) {
	    opponent = player2;
	} else {
	    opponent = player1;
	}
	
  
	int[] tab;
	if(rules.verif(i,name) && player.getTurn()) {
	    replay = rules.replay(i,name);
	    tab = rules.move(i,name);
	    opponent.print(rules.msg(i,false));
	    player.print(rules.msg(i,true));
	} else {
	    log(name+" tried a bad move:"+i);
	}
	
	
	int win = rules.win(name);
    	    
	if (win == -1) {
	    opponent.print("draw ..");
	    player.print("draw ..");
	}
	if (win == 1) {
	    opponent.print("you loose");
	    player.print("you win");
	}
	if (win == 2) {
	    opponent.print("you win");
	    player.print("you loose");
	}   
	
	if (win != 0) {
	    log("end .. ");
	    player.setTurn(false,rules.getTab(name)); 
	    opponent.setTurn(false,rules.getTab(opponent.getName()));
	} else {
	    player.setTurn(replay,rules.getTab(name));
	    opponent.setTurn(! player.getTurn(),rules.getTab(opponent.getName()));
	}
	
	
    }
}

  






