import java.net.*;
import java.io.*;
import java.util.StringTokenizer;
import java.util.Hashtable;
import java.util.Enumeration;

/**
 *@see ServM
 *@author Pierre-Mikael Legris (plegris@fbwww.epfl.ch)
 */
public class Admin implements Runnable 
{
  private Socket s = null;
  private DataInputStream sin = null;
  private PrintStream sout = null;
  private Thread me; 
  boolean creating = false;
  boolean loged = false;
  jSave data;
  
  /** 
   * Construct a new Admin console and launch the Thread
   */
  public Admin(Socket mainSocket) 
    {
      try {
	s = mainSocket;
      }  catch(Exception e) { 
	log(e + "\n cannot get the socket"); 
      }  
      Thread me = new Thread(this);
      me.start();
    } 

  /**
   * Reads the stream, parses the Input 
   */
  public void run () {
    
    try {
      // Open Hsocket and stream
      sin = new DataInputStream(s.getInputStream());
      sout = new PrintStream(s.getOutputStream());
    }
    catch(Exception e) {
      log("*error*" + e +"\n cannot open Hsocket") ;
      me.stop();
    }
    // Open Data
    open();
    if (! creating) {
      print("enter your password");
    }
    String ligne = "";
    while ( s != null ) 
      {
	try {
	  ligne=sin.readLine();
	  try { Thread.sleep(500); } catch(InterruptedException e){ }
	} catch (Exception e) {
	  log("admin deconnected");
	  die();
	  break ;
	}
	
	parseS(ligne);
	
      }
  } // run

  /**
   * Parse the stream
   */
  void parseS(String ligne) {
    if (creating) { //Data creation
      data = new jSave();
      data.password = ligne;
      save();
      print("Password set to :"+ligne);
      loged = true;
      creating = false;
    } else {
      if (! loged) { //Password athentification
	if (ligne.compareTo(data.password) == 0) {
	  loged = true;
	  print("Passwd OK");
	} else {
	  print("Wrong Password");
	  log("Wrong Password"+ligne+" from "+s.getInetAddress());
	  die();
	}
      } else { // Stream managing
	StringTokenizer st = new StringTokenizer(ligne);
	char commande = st.nextToken().charAt(0);
	switch(commande) {
	case 'H': // help
	  print("*** HELP ***\n R - rehash the server\n S - save the data \n P <password> - change the password \n C <class> <game> - add a computer \n G <name> <rules> <board> <author> -add a game\n Q - quit \n g <name> - delete an game\n c <nick> - remove a computer \n L - list the datas");
	  break;
	
	  
	case 'R': //rehash
	  ServM.rehash();
	  print("rehashing server");
	  break;        
	  
	case 'S': //save the data
	  save();
	  break;
	  
	case 'P': //change password
	  if (st.hasMoreTokens()) {
	    data.password = st.nextToken();
	    save();
	    print("password set to: "+data.password);
	  } 
	  break;
	  
	case 'G': //add an entry
	  if (st.countTokens() > 3) {
	    String name = st.nextToken();
	    String field = st.nextToken()+","+st.nextToken()+",";
	    while (st.hasMoreTokens())
	      field +=" "+st.nextToken(); 
	    data.games.put(name,field);
	    print("added: "+ name + " *  "+field+"\n !! data not saved");
	  }
	  break;

	case 'C': //add a computer
	  if (st.countTokens() > 1) {
	    String name = st.nextToken();
	    String field = st.nextToken();
	    while (st.hasMoreTokens())
	      field +=" "+st.nextToken(); 
	    data.computers.put(name,field);
	    print("added: "+ name + " *  "+field+"\n !! data not saved");
	  }
	  break;

	case 'Q': //quit
	  die();
	  break;
	  
	case 'c': //delete a computer
	  if (st.hasMoreTokens()) {
	     String name = st.nextToken();
	     data.computers.remove(name);
	     print("removed: "+name+"\n !! data not saved");
	  }
	  break;
   
	case 'g': //delete an entry
	  if (st.hasMoreTokens()) {
	     String name = st.nextToken();
	     data.games.remove(name);
	     print("removed: "+name+"\n !! data not saved");
	  }
	  break;
	  
	case 'L': //list the data
	  int i = 0;
	  print("** games list **");
	  try {
	    for (Enumeration en=data.games.keys();en.hasMoreElements();i++) {
	      String key = (String) en.nextElement();
	      print(i+" "+key+": "+(String) data.games.get(key));
	    }
	  } catch(Exception e) {log(""+e); } 
	  print("** computers list **");
	  try {
	    for (Enumeration en=data.computers.keys();en.hasMoreElements();i++) {
	      String key = (String) en.nextElement();
	      print(i+" "+key+": "+(String) data.computers.get(key));
	    }
	  } catch(Exception e) {log(""+e); } 
	  
	  break;


	}
      }
    }
  }



  /** 
   * Save the datas
   */
  void save() {
    FileOutputStream st1 = null;
    ObjectOutputStream st2 = null;
    try {
      st1 = new FileOutputStream("jGame.dat");
      st2 = new ObjectOutputStream(st1);
      st2.writeObject(data);
    }
    catch(IOException ex) {
      log("error while saving"+ex);
    }
    finally {
      try {
	if (st2 != null)
	  st2.close();
	if (st1 !=null)
	  st1.close();
      }
      catch (IOException ex) {
	log("error while saving"+ex);
      }
    }
    log("*** data saved");
    
  }
  
  /**
   * Read jsave
   */  
  void open() {
    FileInputStream st1 = null;
    ObjectInputStream st2 = null;
    try {
      st1 = new FileInputStream("jGame.dat");
      st2 = new ObjectInputStream(st1);
      Object obj = st2.readObject();
      data = (jSave)obj;
    }
    catch(IOException ex) {
      String temp = "java.io.FileNotFoundException: jGame.dat";
      if ( temp.compareTo(""+ex) == 0) {
	newData();
      } else {
	 log("error while reading "+ex);
	 die();
      }
    }
    catch(ClassNotFoundException ex) {
      log("Class not found"+ex);
      die();
    }
    finally {
      try {
	if (st2 != null)
	  st2.close();
	if (st1 !=null) 
	  st1.close();
      }
      catch (IOException ex) {
	log("error while reading (closing)"+ex);
	die();
      }
    }
  }  

  //newData
  void newData() {
    creating = true;
    print("jGame.dat does not exists\nplease enter a  new Password");
  }

  //PRINT
  void print(String msg) {
    sout.println(msg);
  }

  // LOG
  void log(String msg)
  {
    System.out.println("Admin: " + msg);
    print("Log: "+msg);
  }
  
  // DIE
  void die() {
    try {
      s.close();
    } catch(Exception ee) {}
  }

} // Admin




