
import java.net.*;
import java.io.*;

/**
 * usage Human(String nick, Socket , String comment)
 * This object define a user by a comment a score and a socket
 *
 *@see ServM
 *@author Pierre-Mikael Legris (plegris@fbwww.epfl.ch)
 */
public class Human extends Player implements Runnable
{
  private Thread h;
  Socket mySocket = null;
  String play = "-";
  String ask = "-" ;
  String asker = "-" ;
  String game = "-" ;
  int score = 0;
  PrintStream MyP = null;
  DataInputStream MyR = null;
  private String buf = "";
  boolean alive = false;
  private boolean turn = false;

  // constructor
  /** 
   * Construct a new Human and launch the Thread
   */
  public Human(String nick, Socket Hsocket,String comm) {
    super(nick,comm,false);
    mySocket = Hsocket; 
    Thread h = new Thread(this);
    h.start();   
  }

  // run
  /**
   * Reads the stream, and put the result in buf until someone read it
   */
  public void run ()
  {
    alive = true;
    try {
      MyP = new PrintStream(this.mySocket.getOutputStream());
      MyR =  new DataInputStream(this.mySocket.getInputStream());
    }  catch(Exception e) { }
    
    while (mySocket != null ) {
      try {
	if (this.buf.compareTo("") == 0) {
	  this.buf=MyR.readLine();
	}
      } catch (Exception e) {
	die();
	break;
      }
      try{ Thread.sleep(100); } catch(InterruptedException e){ }
    }  
  }

  
  String getAddy () { return ""+mySocket.getInetAddress().getHostName();}
  String getInfo () { return info; }
  String getAsk () { return ask; }
  int getScore () { return score; }
  String getGame () { return game; }
  String getPlay () { return play; }
  String getAsker () { return asker; }
  boolean isAlive () {
    if ((mySocket != null) && alive ) {
      return true; 
    } else {
      return false;
    }
  }

  boolean playing() { 
    if ( play.compareTo("-") == 0 ) {
      return false;
    } else {
      return true;
    }
  }
  boolean asking() {
    if ( ask.compareTo("-") == 0 ) {
      return false;
    } else {
      return true;
    }
  }
  boolean asked() {
    if ( asker.compareTo("-") == 0 ) {
      return false;
    } else {
      return true;
    }
  }

  
  /**
   * Print a string to the socket
   */
  synchronized boolean send (String msg) {
    if (isAlive()) {
      try {
	MyP.println(msg);
      } catch(Exception e) { die(); return false; }
      return true;
    } else {
      return false;
    }
  }
  
  String getNick() {
    return myNick;
  } 
  
  boolean hisTurn () {
    return turn;
  } 

   synchronized void setTurn(boolean play) {
    this.turn = play;
    send("T<"+play);
  } 

  synchronized void setGame (String gamez) {
    this.game = gamez;
  }
  synchronized void setAsk (String asked) {
    this.ask = asked;
  }
  synchronized void setAsker (String nick) {
    this.asker = nick;
  }
  synchronized void setPlay (String player) {
    this.play = player;
  }

  synchronized void setScore (int newscore) {
    this.score = newscore;
  }
  
  synchronized void part() {
    setPlay("-");
  } 
  
  synchronized void delAsk (String nick) {
    if (nick.compareTo(this.ask) == 0 ) {
      this.asker = "-";
    }
  }
  
  /**
   * Give what's in the buffer and init it
   */
  synchronized String read() {
    String ligne = this.buf;
    this.buf = "";
    return ligne;
  }
  
  synchronized void delAsker (String who) {
    if (who.compareTo(this.asker) == 0 ) {
      this.asker = "-";
    }
  }
  
  synchronized void clean () {
    this.score = 0;
    this.game = "-";
    this.ask = "-";
    this.asker = "-";
    this.play = "-";
  }

  /**
   * Kill the user: send the quit string to the server, remove the user from ServM user list and close the socket. 
   */
  synchronized void die () {
    try {
      if (alive != false ) {
	log("@"+getAddy()+" has quit" );
	ServM.bdM("Q<"+myNick);
      }
      alive = false;
      ServM.users.remove(myNick);
      mySocket.close();
    } catch(Exception ee) {} 
  }
  
   // LOG
  void log(String msg)
  {
    // System.out.println("Human: "+ myNick + " " + msg);
  }
} //Human










