
import java.net.*;
import java.io.*;
import java.util.StringTokenizer;
import java.util.Hashtable;
import java.util.Enumeration; 
/**
 *
 * <PRE>
 * Code strings going thru Mstream
 * from the  player
 * C who game message - connection requirement
 *                     return C
 * G - game list required
 * W - user list required (not used)
 * Q - users quit
 * A who message - accept connection with [who]
 *                      return A 
 *-
 * for the player
 * C N message - cannot ask [who]
 *   W - wait .. asking [who]  (cf R string for another player)
 * A N message - cannot connect
 *   Y - - connected (cf Z string for another player)
 * L nick1>info1>from1>playing1>nick2>... give the userlist
 * G name1:field1#name2:field2# ... give the gamelist
 * -
 * for another player
 * R myNick game message - ask [who]
 * Z Y myNick message - connect 
 * </PRE>
 *@see ServM
 *@author Pierre-Mikael Legris (plegris@fbwww.epfl.ch)
 */
public class Mstream implements Runnable
{
  private Thread IO;
  private String nick;
  private Player player = null;
  
  /** 
   * Construct a new Mstream and launch the Thread
   * for a Player
   */
  public Mstream(String token) 
  {
    nick = token;
    player = (Player) ServM.users.get(nick);
    ServM.bdU(nick);
    Thread IO = new Thread(this);
    IO.start();
  } 
  
  /**
   * Reads the stream, parses the Input 
   */
  public void run()
  { 
    String ligne = "";
    StringTokenizer st;
    try{ Thread.sleep(1000); } catch(InterruptedException e){ }
    try { uli(); gli();} catch(Exception e){ }
    player.clean();
    while ( (player.isAlive()) && (! player.playing()) ) {
      try {
	ligne = player.read();
	st = new StringTokenizer(ligne,"<");
        
	if (st.countTokens() == 2) {
	  char commande = st.nextToken().charAt(0);
	  parseS(commande,st.nextToken(),player.playing());
	}
      } catch(Exception e){ }

      try{ Thread.sleep(100); } catch(InterruptedException e){ }
    }
    player.setAsk("-");
    try{ ServM.bdU(nick);} catch(Exception e){ }
    log("left");
  } // run
  
  // parseS
  /**
   * parse the input stream 
   */
  void parseS(char comm,String arg,boolean playing)
  {
    StringTokenizer st;
    String who ="";
    String game ="";
    switch(comm) {
    case 'C' : // connection required
      if ( playing ) {
	fb("C<N>You are actually playing");
	break;
      }
      st = new StringTokenizer(arg,">");
      if (st.countTokens() == 3) {
	who = st.nextToken();
	game = st.nextToken();
	String gameStr = (String) ServM.games.get(game);
	Player required = (Player) ServM.users.get(who);
	if (! required.isAlive()) {
	  if (player.getAsk().compareTo(who) == 0) { player.delAsk(who);}
	}
	if (gameStr == null) {
	  fb("C<N>I dunno the game: "+game);
	  break;
	}
	if ( required == null ) {
	  fb("C<N>"+who+" doesn't exist");
	  break;
	}
	if (this.nick.compareTo(who) == 0) {
	  fb("C<N>You dumb! This is you!");
	  break;
	}
	if (required.bot) {
	  if (required.iPlay.compareTo(game) == 0) {
	    startGame(required,who,game);
	  } else {
	    fb("A<N>"+who+" only plays to "+required.iPlay);
	  }
	  break;
	}
	if (required.playing()) {
	  fb("C<N>"+who+" is already playing");
	  break;
	}
	if (required.asking()) {
	  Player asker = (Player) ServM.users.get(required.getAsk());
	  if ((asker != null) && ( asker.isAlive())) {
	    fb("C<N>"+who+" is waiting for "+required.getAsk()+" to play");
	    break;
	  }
	}
	if (required.asked()) {
	  fb("C<N>"+who+" is already required by "+required.getAsker() );
	  break;
	}
	if(required.send("R<"+nick+">"+game+">"+st.nextToken()))
	   {
	     player.setAsk(who);
	     player.setGame(game);
	     required.setAsker(nick);
	     fb("C<W>Asking "+who+" agreement to play");
	   } else {
	     fb("C<N>Cannot reach "+who);
	   }
      }
      break;

    case 'G' : // gamelist required
      gli();
      break;
      
    case 'W' : // userlist required
      uli();  
      break;

    case 'Q' : // user leave
      player.die();
      break;

    case 'A' : // requirement reply
      st = new StringTokenizer(arg,">");
      if (st.countTokens() == 3) {
	who = st.nextToken();
	Player required = (Player) ServM.users.get(who);
	if ( required == null ) {
	  fb("A<N>"+who+" doesn't exist");
	  player.delAsker(who);
	  break;
	}
	if (who.compareTo(player.getAsker()) != 0 ) {
	  fb("A<N>"+who+" doesn't want to play with you");
	  break;
	}
	if (nick.compareTo(required.getAsk()) != 0) {
	  fb("A<N>"+who+" doesn't want to play with you anymore");
	  player.delAsker(who);
	  break;
	}
	
	String game2 = required.getGame();
	player.clean();
	required.clean();
	if ( st.nextToken().compareTo("N") == 0) {
	  if (required.send("Z<N>"+st.nextToken()))
	    {
	      log("refused to play with " + who);
	    } else {
	      fb("A<N>Cannot reach "+who);
	    }
	} else {
	  String dBoard = getClass(game2,"b");
	  if (required.send("Z<Y>"+nick+">"+dBoard+">"+st.nextToken()))
	    {
	      startGame(required,who,game2);
	    } else {
	      fb("A<N>Cannot reach "+who);
	    }
	}
      }
      break;
    }

  }// parseS
  
  // start a new game
  void startGame(Player required,String who,String game) {
    String dBoard = getClass(game,"b");
    String dRules = getClass(game,"r");
    player.setPlay(who);
    required.setPlay(nick);
    fb("A<Y>"+who+">"+dBoard+">"+required.getWelcome());
    Game ourGame = new Game(who,nick,dRules);
    log("started a game with " + who);
  }


  // getClass from ServM.games
  String getClass(String key,String type) { 
    String temp = (String) ServM.games.get(key);
    StringTokenizer st = new StringTokenizer(temp);
    temp = st.nextToken();
    log("temp :"+temp);
    StringTokenizer st2 = new StringTokenizer(temp,",");
    String rules = st2.nextToken();
    String board = st2.nextToken();
    if (type.compareTo("b") == 0) 
      return board;
    return rules;
  }


  // FeedBack
  void fb(String msg)
  {
    player.send(msg);
  }

  // Give the Game List
  void gli()
  {
    String tmp = "G<";
    for (Enumeration en = ServM.games.keys() ; en.hasMoreElements() ;) {
      String key = (String) en.nextElement();
      String game = (String) ServM.games.get(key);
      tmp += key+":"+game+"#";
    }
    fb(tmp); 

  }
  
  // Give ULI
  void uli() 
  {
    String tmp = "L<";
    for (Enumeration en = ServM.users.keys() ; en.hasMoreElements() ;) {
      String key = (String) en.nextElement();
      Player tempH = (Player) ServM.users.get(key);
      tmp = tmp +key+">"+tempH.getInfo()+">"+tempH.getAddy()+">"+tempH.getPlay() +">";
    }
    fb(tmp);  
  }

   // LOG
  void log(String msg)
  {
    // System.out.println("Mstream: "+ this.nick + " " + msg);
  }
}





