
import java.net.*;
import java.io.*;
import java.util.StringTokenizer;
import java.util.Hashtable;
import java.util.Date;

/**
 *@see ServM
 *@author Pierre-Mikael Legris (plegris@fbwww.epfl.ch)
 */
public class SocketHub implements Runnable 
{
  private Socket Hsocket = null;
  private DataInputStream IH = null;
  private PrintStream PH = null;
  private Thread SH; 

  /** 
   * Construct a new SocketHub and launch the Thread
   */
  public SocketHub(Socket mainSocket) 
    {
      try {
	Hsocket = mainSocket;
      }  catch(Exception e) { 
	log(e + "\n cannot get the socket"); 
      }
      
      Thread SH = new Thread(this);
      SH.start();
    } 
  
  /**
   * Reads the stream, parses the Input until the entry is valid
   */
  public void run () {
    try {
      // Open Hsocket and stream
      IH = new DataInputStream(Hsocket.getInputStream());
      PH = new PrintStream(Hsocket.getOutputStream());
    }
    catch(Exception e) {
      log("*error*" + e +"\n cannot open Hsocket") ;
    }
    
    String ligne = "";
    while ( Hsocket != null ) 
      {
	try {
	  ligne=IH.readLine();
	  try { Thread.sleep(500); } catch(InterruptedException e){ }
	  
	  if (ligne.compareTo("admin") == 0) {
	    Admin adm = new Admin(Hsocket);
	    break;
	  }

	  StringTokenizer st = new StringTokenizer(ligne,"<");
	  if ((st.countTokens() == 2) && Hsocket != null);
	  {
	    String tnick = st.nextToken();
	    if ( validNick( tnick , st.nextToken()) )
	      {
		ServM.bdM("J<"+tnick);
		Mstream manca = new Mstream( tnick );
		
		break;
	      }
	  }
	}
	catch (Exception e) {
	  log("*error*" + e +" lost connection");
	  try {
	    Hsocket.close();
	  } catch(Exception ee) {}
	  break ;
	} 
      }
  } // run
  
  // validNick 
  /** 
   * Check if the nick is valid and add it in the userlist
   */
  boolean validNick(String nick, String comment)
  {
    if (ServM.users.get(nick) == null) {
      System.out.println(""+new Date()+" "+Hsocket.getInetAddress().getHostName());
      ServM.users.put(nick , new Human(nick, Hsocket , comment ) );
      PH.println("Y<"+nick);
      return true;
    } else {
      PH.println("N<"+nick+" exists, please choose another one");
      return false;
    }  
  }// validNick
   
  // LOG
  void log(String msg)
    {
      // System.out.println("socketHub: " + msg);
    }
} // SocketHub
